<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body>
    <script>
      // объявляем класс транспортное средство
      class Vehicle {
        static COMMON_TYPE = "VEHICLE";

        constructor(type) {
          this.type = type;
        }

        getType() {
          return this.type;
        }
      }

      const vehicle = new Vehicle("ffff");

      // объявляем класс машина, который наследует класс транспортное средство
      class Car extends Vehicle {
        constructor(type, brand) {
          // ключевое слово super вызывает конструктор родителя с аргументами нужными ему
          super();
          this.brand = brand;
        }
      }
      const car = new Car("ffff", "tesla");

      // объявляем класс автобус, который наследует класс транспортное средство
      class Bus extends Vehicle {
        constructor(type, capacity) {
          // ключевое слово super вызывает конструктор родителя с аргументами нужными ему
          super(type);
          this.capacity = capacity;
        }

        getCapacity() {
          const type = super.getType();
          if (type === Vehicle.COMMON_TYPE) {
            return this.capacity + 100;
          }

          return this.capacity;
        }
      }

      const bus = new Bus("ffff", 38);

      const newCar = new Car("vehicle", "tesla");
      const newBus = new Bus("vehicle", 28);
      console.log(newCar.type);
      console.log(newCar.brand);
      console.log(newBus.type);
      console.log(newBus.capacity);

      console.log(newBus.getCapacity());

      // Оператор вернёт true, если newCar принадлежит классу Car или наследующему от него.
      console.log(newCar instanceof Car);
    </script>
  </body>
</html>
